unit getkey;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, menus, IniFiles;

type
  TfrmSetup = class(TForm)
    btnSave: TButton;
    btnClose: TButton;
    GroupBox2: TGroupBox;
    rbDblClick: TRadioButton;
    rbOneClick: TRadioButton;
    cbFileOpen: TCheckBox;
    cbSound: TCheckBox;
    cbMessages: TCheckBox;
    cbAutoDrop: TCheckBox;
    cbSendMsg: TCheckBox;
    Label3: TLabel;
    eMsgText: TMemo;
    procedure btnCloseClick(Sender: TObject);
    procedure btnSaveClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const
  INIFile = 'sharemon.ini';

var
  frmSetup: TfrmSetup;
  SSKey: integer;
  ini: TIniFile;

implementation

{$R *.DFM}

procedure TfrmSetup.btnCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmSetup.btnSaveClick(Sender: TObject);
var
  path: string;
begin
  path := ExtractFilePath(application.ExeName);
  if path[length(path)] <> '\' then
    path := path + '\';
  ini := TIniFile.Create(path + INIFile);
  try
    ini.WriteBool('Settings', 'DblClick', rbDblClick.Checked);
    ini.WriteBool('Settings', 'FileOpen', cbFileOpen.Checked);
    ini.WriteBool('Settings', 'Sound', cbSound.Checked);
    ini.WriteBool('Settings', 'Messages', cbMessages.Checked);
    ini.WriteInteger('Settings', 'SSKey', SSKey);
    ini.WriteBool('Settings', 'AutoDrop', cbAutoDrop.Checked);
    ini.WriteBool('Settings', 'AutoDrop', cbSendMsg.Checked);
    ini.WriteString('Settings', 'MsgText', eMsgText.Text);
  finally
    ini.Free();
  end;
  Close;
end;

procedure TfrmSetup.FormCreate(Sender: TObject);
var
  path, s: string;
begin
  path := ExtractFilePath(application.ExeName);
  if path[length(path)] <> '\' then
    path := path + '\';
  ini := TIniFile.Create(path + INIFile);
  try
    s := ShortCutToText(ini.ReadInteger('Settings', 'SSKey', 0));
    if s = '' then
      s := '[' + s + ']';
    rbDblClick.Checked := ini.ReadBool('Settings', 'DblClick', true);
    rbOneClick.Checked  := not ini.ReadBool('Settings', 'DblClick', true);
    cbFileOpen.Checked := ini.ReadBool('Settings', 'FileOpen', true);
    cbSound.Checked := ini.ReadBool('Settings', 'Sound', true);
    cbMessages.Checked := ini.ReadBool('Settings', 'Messages', true);
    cbAutoDrop.Checked := ini.ReadBool('Settings', 'AutoDrop', true);
    cbAutoDrop.Checked := ini.ReadBool('Settings', 'AutoDrop', true);
    cbSendMsg.Checked := ini.ReadBool('Settings', 'AutoDrop', true);
    eMsgText.Text := ini.ReadString('Settings', 'MsgText',
      'Your activity is being logged!');
  finally
    ini.Free();
  end;
end;

end.

