unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, getUser, ExtCtrls, MMSystem, Menus, ComCtrls,
  Buttons, ImgList, XPMan, CoolTrayIcon;

type
  TfrmMain = class(TForm)
    Timer1: TTimer;
    infoPC: TListView;
    FileList: TListView;
    btnOff: TButton;
    btnRefresh: TButton;
    btnLog: TSpeedButton;
    btnSetup: TSpeedButton;
    ImageList1: TImageList;
    ImageList2: TImageList;
    XPManifest1: TXPManifest;
    TrayIcon: TCoolTrayIcon;
    procedure Timer1Timer(Sender: TObject);
    procedure btnRefreshClick(Sender: TObject);
    procedure messageget(path: string);
    procedure FormCreate(Sender: TObject);
    procedure TrayIconMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
    procedure btnLogClick(Sender: TObject);
    procedure WMHotKey(var Msg: TWMHotKey); message WM_HOTKEY;
    procedure menuSetupClick(Sender: TObject);
    procedure btnOffClick(Sender: TObject);
    procedure btnFilesClick(Sender: TObject);
    procedure FileListKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure infoPCClick(Sender: TObject);
    procedure TrayIconClick(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure btnMinimizeClick(Sender: TObject);
    procedure TrayIconDblClick(Sender: TObject);
  private
    { Private declarations }
  public

    { Public declarations }
  end;

var
  frmMain: TfrmMain;
  path, path1: string;
  clo: boolean;
  LFile: TStringList;
  LFName: string;
  UsrLst: TListView;
  ClickClick, AlarmOpenFiles, ShowHints, DoPlaySound: boolean;

implementation

uses getkey, registry, fLog;

{$R *.DFM}

const
  id_SnapShot = 101;

//-----------------------------------------------------------------------------
// Get list of open files
//-----------------------------------------------------------------------------
function ShowSes(st: string): boolean;
begin
  if (frmSetup.cbFileOpen.Checked) and (frmSetup.cbMessages.Checked) then
  begin
    Result := false;
    exit;
  end;
  Result := getFilesExc(st);
end;

//-----------------------------------------------------------------------------
// Detect hotkey
//-----------------------------------------------------------------------------
procedure TfrmMain.WMHotKey(var Msg: TWMHotKey);
begin
  if Msg.HotKey = id_SnapShot then
    SendMessage(GetDeskTopWindow, WM_SYSCOMMAND, SC_SCREENSAVE, 0)
end;

//-----------------------------------------------------------------------------
// Play sound
//-----------------------------------------------------------------------------
procedure TfrmMain.MessageGet(path: string);
begin
  if frmSetup = nil then exit;
  if (path <> '') and frmSetup.cbSound.Checked and (WaveOutGetNumDevs()>0) then
    PlaySound(pChar(path), hInstance, SND_FILENAME);
end;

//-----------------------------------------------------------------------------
// Main process is here
//-----------------------------------------------------------------------------
procedure TfrmMain.Timer1Timer(Sender: TObject);
var
  i, ii, l: integer;
  flag: boolean;
  pc, usr, msg: string;
begin
  Timer1.Enabled := false;
  try
  //  TrayIcon.HideBalloonHint();
  //  TrayIcon.CycleIcons := false;
  //  TrayIcon.IconIndex := 0;
    btnOff.Enabled := (infoPC.Selected <> nil);
    if frmSetup = nil then
      exit;
    UsrLst.Items.Clear;
    GetConnected(UsrLst);

    // Check disconnections
    for i := 0 to infoPC.Items.Count - 1 do
    begin
      flag := false;
      pc := trim(infoPC.Items[i].Caption);
      usr := trim(infoPC.Items[i].SubItems[0]);
      for ii := 0 to UsrLst.Items.Count - 1 do
      begin
        if (pc = trim(UsrLst.Items[ii].Caption)) and
           (usr = trim(UsrLst.Items[ii].SubItems[0])) then
        begin
          flag := true;
          break;
        end;
      end;
      if not flag then
      begin
        msg := DateTimeToStr(now) + ' Disconnect: ' + pc + ' (' + usr + ')';
        LFile.Add(msg);
        if frmSetup.cbMessages.Checked then
          TrayIcon.ShowBalloonHint('', msg, bitWarning, 10);
      end;
    end;
    if (UsrLst.Items.Count < 1) and (infoPC.Items.Count > 1) then
    begin
      TrayIcon.CycleIcons := true;
      MessageGet(path1);
      LFile.SaveToFile(LFName);
    end;

    l := LFile.Count;
    //Check connections
    for i := 0 to UsrLst.Items.Count - 1 do
    begin
      flag := false;
      pc := trim(UsrLst.Items[i].Caption);
      usr := trim(UsrLst.Items[i].SubItems[0]);
      for ii := 0 to infoPC.Items.Count - 1 do
        if (trim(infoPC.Items[ii].Caption) = pc) and
          (trim(infoPC.Items[ii].SubItems[0]) = usr) then
         begin
           flag := true;
           break;
         end;
      if (not flag) then
      begin
        msg := DateTimeToStr(now) + ' Connected: ' + pc + ' (' + usr + ')';
        LFile.Add(msg);
        if frmSetup.cbMessages.Checked then
          TrayIcon.ShowBalloonHint('', msg, bitWarning, 10);
        if frmSetup.cbSendMsg.Checked then
          WinExec(Pchar('net send ' + pc + ' ' +  frmSetup.eMsgText.Text), SW_HIDE);
      end;
      if (ShowSes(UsrLst.Items[i].SubItems[0])) then
         if (frmSetup.cbFileOpen.Checked) and (frmSetup.cbMessages.Checked) then
          TrayIcon.ShowBalloonHint('', 'File opened by ' + pc +
             ' (' + usr + ')', bitWarning, 10);
    end;
    if l <> LFile.Count then
    begin
      TrayIcon.CycleIcons := true;
      messageget(path);
      LFile.SaveToFile(LFName);
    end;
    infoPC.Items.Assign(UsrLst.Items);
    if infoPC.Items.Count > 0 then
    begin
      //infoPC.Items[0].Selected:=true;
      if frmSetup.cbAutoDrop.Checked then
        for i := 0 to infoPC.Items.Count - 1 do
          CloseSession(i, infoPC.Items[i].Caption);
    end
    else if FileList.Items.Count > 0 then
      FileList.Clear();
  finally
    Timer1.Enabled := true;
  end;
end;

//-----------------------------------------------------------------------------
// manual refresh
//-----------------------------------------------------------------------------
procedure TfrmMain.btnRefreshClick(Sender: TObject);
begin
  SystemParametersInfo(SPI_SETSCREENSAVEACTIVE, 1, nil, 1);
  Timer1Timer(Sender);
end;

//-----------------------------------------------------------------------------
// Init variables and load configuration
//-----------------------------------------------------------------------------
procedure TfrmMain.FormCreate(Sender: TObject);
var
  reg: TRegistry;
  WinNT: boolean;
begin
  DateSeparator := '-';

  UsrLst := TListView.Create(owner);
  UsrLst.Parent := frmMain;
  UsrLst.Visible := false;
  UsrLst.Columns := infoPC.Columns;
  if not IsNT(WinNT) then
  begin
    ShowMessage('Uncompatible Windows version');
    Application.Terminate;
    exit;
  end;
  if WinNT then
    Caption := '..:: Windows Share Monitor [WinNT]'
  else
    Caption := '..:: Windows Share Monitor [Win9x]';
  reg := TRegistry.Create;
  reg.RootKey := HKEY_LOCAL_MACHINE;
  if (reg.OpenKey('Software\Microsoft\Windows\CurrentVersion\Run\', false)) then
  begin
    reg.WriteString('Connections Monitor', application.ExeName);
    reg.CloseKey;
  end;
  reg.Destroy;

  LFile := TStringList.Create;
  LFile.Clear;
  LFName := path + datetostr(now) + '.log';
  if FileExists(LFName) then
    LFile.LoadFromFile(LFName);

  path1 := path + 'music1.wav';
  path := path + 'music.wav';
  Timer1Timer(Sender);
end;

procedure TfrmMain.TrayIconMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
//  TrayIcon.Hint := 'Network connections: [active ' +
//    IntToStr(infoPC.Items.count) + ']'
end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  UsrLst.Free;
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
  if LFile.Count > 0 then
    LFile.SaveToFile(LFName);
  UnRegisterHotKey(Handle, id_SnapShot);
end;

procedure TfrmMain.btnLogClick(Sender: TObject);
begin
  frmLog.memo1.Lines := LFile;
  frmLog.Show();
end;

procedure TfrmMain.menuSetupClick(Sender: TObject);
begin
  frmSetup.ShowModal();
end;

//-----------------------------------------------------------------------------
// Disconnect user
//-----------------------------------------------------------------------------
procedure TfrmMain.btnOffClick(Sender: TObject);
begin
  if infoPC.Selected = nil then
    exit;
  if Application.MessageBox('Do you want to close this connection?',
    '', MB_ICONQUESTION or MB_YESNO or MB_DEFBUTTON2) <> ID_YES then
    exit;
  CloseSession(infoPC.Selected.Index, infoPC.Selected.Caption);
  BtnRefreshClick(Sender);
end;

procedure TfrmMain.btnFilesClick(Sender: TObject);
begin
  frmLog.memo1.Lines.Text := '';
  if infoPC.Selected <> nil then
    getFilesList(FileList, infoPC.Selected.SubItems[0]);
end;

//-----------------------------------------------------------------------------
// Disconnect user from file
//-----------------------------------------------------------------------------
procedure TfrmMain.FileListKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  OS: Boolean;
  FLibHandle: THandle;
  i: Integer;
begin
  if key = vk_delete then
  begin
    if Application.MessageBox('Do you want to close this file?', '',
      MB_ICONQUESTION or MB_YESNO) <> ID_YES then exit;
    if not IsNT(OS) then
      Close;        //OS Detection

    if not Assigned(FileList.Selected) then
      Exit;
    i := FileList.Selected.Index; //File number detection

    if OS then
    begin
      FLibHandle := LoadLibrary('NETAPI32.DLL');
      if FLibHandle = 0 then
        Exit;
      @NetFileClose := GetProcAddress(FLibHandle, 'NetFileClose');
      if not Assigned(NetFileClose) then
      begin
        FreeLibrary(FLibHandle);
        Close;
      end;
      NetFileClose(nil, StrToInt(FileList.Items.Item[i].SubItems[0]));
    end
    else
    begin           //Windows 9x-Me
      FLibHandle := LoadLibrary('SVRAPI.DLL');
      if FLibHandle = 0 then
        Exit;
      @NetFileClose2 := GetProcAddress(FLibHandle, 'NetFileClose2');
      if not Assigned(NetFileClose2) then
      begin
        FreeLibrary(FLibHandle);
        Close;
      end;
      NetFileClose2(nil, StrToInt(FileList.Items.Item[i].SubItems[0]));
    end;
    FreeLibrary(FLibHandle);
    getFilesList(FileList, infoPC.Selected.SubItems[0]);
  end;
end;

procedure TfrmMain.infoPCClick(Sender: TObject);
begin
  if (FileList.Visible) and (infoPC.Items.Count > 0) then
    if infoPC.Selected <> nil then
      getFilesList(FileList, infoPC.Selected.SubItems[0]);
end;

procedure TfrmMain.TrayIconClick(Sender: TObject);
begin
  if not frmSetup.rbDblClick.Checked then
  begin
    TrayIcon.ShowMainForm();  
    BringToFront();
  end;
end;

procedure TfrmMain.btnCloseClick(Sender: TObject);
begin
  if MessageDlg('Close Intrusion Blocker now?', mtConfirmation,
    [mbYes, mbNo], 0) = mrYes then
    Close();
end;

procedure TfrmMain.btnMinimizeClick(Sender: TObject);
begin
//  TrayIcon.HideMainForm();
end;

procedure TfrmMain.TrayIconDblClick(Sender: TObject);
begin
  if frmSetup.rbDblClick.Checked then
  begin
    TrayIcon.ShowMainForm();
    BringToFront();
  end;
end;

end.

